/***********************************************
*  $B1U>=I=<(4o%i%$%V%i%j(B
*  I2C$B%$%s%?!<%U%'!<%9(B
*    lcd_init()    ----- $B=i4|2=(B
*    lcd_cmd(cmd)  ----- $B%3%^%s%I=PNO(B
*    lcd_data(data) ----- $B#1J8;zI=<(=PNO(B
*    lcd_str(ptr)  ----- $BJ8;zNsI=<(=PNO(B
*    lcd_clear()   ----- $BA4>C5n(B
**********************************************/
#include <xc.h>
#include "lcd_i2c_lib.h"


/********************************
*  $BD4@0MQDj?t(B
*********************************/
//#define CONTRAST	0x18		// for 5.0V
#define CONTRAST  0x30		// for 3.3V
/*********************************
*$B!!%"%$%3%s$NDj5A(B
*********************************/
const unsigned char Mark[14][2]={
	{0x00, 0x10},		// $B%"%s%F%J(B
	{0x02, 0x10},		// $BEEOC(B
	{0x04, 0x10},		// $BL5@~(B
	{0x06, 0x10},		// $B%8%c%C%/(B
	{0x07, 0x10},		// $B"$(B
	{0x07, 0x08},		// $B"&(B
	{0x07, 0x18},		// $B"$"&(B
	{0x09, 0x10},		// $B80(B
	{0x0B, 0x10},		// $B%T%s(B
	{0x0D, 0x02},		// $BEECSL5$7(B
	{0x0D, 0x12},		// $BMFNL>/(B
	{0x0D, 0x1A},		// $BMFNLCf(B
	{0x0D, 0x1E},		// $BMFNLB?(B
	{0x0F, 0x10}		// $B4](B
};
/***************************************************************
* I2C$B%P%9$G(BLCD$B%3%^%s%IAw?.(B
****************************************************************/
void lcd_cmd(unsigned char cmd)
{
    IdleI2C1();
    I2C1CONbits.SEN = 1;   				// $B%9%?!<%H=PNO(B//
    while(I2C1CONbits.SEN);				// $B%9%?!<%H=*N;BT$A(B//
    I2C1TRN = 0x7C;					// $B%"%I%l%9Aw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1TRN = 0x00;					// $B%3%^%s%I;XDjAw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1TRN = cmd;					// $B%3%^%s%IAw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1CONbits.PEN = 1;   				// $B%9%H%C%W=PNO(B//
    while(I2C1CONbits.PEN);				// $B%9%H%C%W=*N;BT$A(B//
    /* Clear$B$+(BHome$B$NBT$A;~4VH=Dj(B*/
    if((cmd == 0x01) || (cmd == 0x02))
        Delay_ms(2);                                     // 2msec
    else
        Delayus(30);
}
/***************************************************************
* I2C$B%P%9$G(BLCD$BI=<(%G!<%?Aw?.(B
****************************************************************/
void lcd_data(unsigned char data)
{
    IdleI2C1();
    I2C1CONbits.SEN = 1;   				// $B%9%?!<%H=PNO(B//
    while(I2C1CONbits.SEN);				// $B%9%?!<%H=*N;BT$A(B//
    I2C1TRN = 0x7C;					// $B%"%I%l%9Aw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1TRN = 0x40;					// $BI=<(%G!<%?;XDjAw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1TRN = data;					// $B%3%^%s%IAw?.(B//
    while(I2C1STATbits.TBF);                            // $BAw?.=*N;BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    Nop();Nop();
    while(I2C1STATbits.ACKSTAT);                      // ACK$BJV?.BT$A(B//
    IdleI2C1();                                         // $B%"%$%I%kBT$A(B//
    I2C1CONbits.PEN = 1;   				// $B%9%H%C%W=PNO(B//
    while(I2C1CONbits.PEN);				// $B%9%H%C%W=*N;BT$A(B//
    Delayus(30);
}
/** $B%"%$%I%kBT$A%5%V4X?t!!(B***/
void IdleI2C1(void)
{
    /* Wait until I2C Bus is Inactive */
    while(I2C1CONbits.SEN || I2C1CONbits.PEN || I2C1CONbits.RCEN
    		 || I2C1CONbits.ACKEN || I2C1STATbits.TRSTAT);
}
/*********************************************************
* $BCY1d4X?t(B  1msec 1usec @40MMHz
**********************************************************/
void Delay_ms( unsigned int t){
    T2CON = 0x8000;                             // enable tmr2, Tcy, 1:1
    while (t--)    {
        TMR2 = 0;
        while (TMR2<40000);
    }
}
void Delayus(unsigned int t)
{
    T2CON = 0x8000;
    while(t--){
       TMR2 = 0;
       while(TMR2 < 40);
    }
}
/*******************************
*  $B=i4|2=4X?t(B
*******************************/
void lcd_init(void)
{
    Delay_ms(100);
    lcd_cmd(0x38);				// 8bit 2line Normal mode
    lcd_cmd(0x39);				// 8bit 2line Extend mode
    lcd_cmd(0x14);				// OSC 183Hz BIAS 1/5
    /* $B%3%s%H%i%9%H@_Dj(B */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
//	lcd_cmd(0x6A);				// Follower for 5.0V
    lcd_cmd(0x6B);				// Ffollwer for 3.3V
    Delay_ms(300);
    lcd_cmd(0x38);				// Set Normal mode
    lcd_cmd(0x0C);				// Display On
    lcd_cmd(0x01);				// Clear Display
}
/******************************
* $BA4>C5n4X?t(B
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);				//$B=i4|2=%3%^%s%I=PNO(B
}
/*****************************
* $BJ8;zNsI=<(4X?t(B
*****************************/
void lcd_str(const unsigned char* ptr)
{
    while(*ptr != 0)				//$BJ8;z<h$j=P$7(B
        lcd_data(*ptr++);			//$BJ8;zI=<((B
}
/*****************************
*  $B%"%$%3%sI=<(@)8f4X?t(B
*****************************/
void lcd_icon(unsigned char num, unsigned char onoff)
{
    lcd_cmd(0x39);				// Extend mode
    lcd_cmd(0x40 | Mark[num][0]);               // $B%"%$%3%s%"%I%l%9;XDj(B
    if(onoff)
        lcd_data(Mark[num][1]);                 // $B%"%$%3%s%*%s%G!<%?(B
    else
        lcd_data(0x00);                         // $B%"%$%3%s%*%U%G!<%?(B
    lcd_cmd(0x38);				// Normal Mode
}

